<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ExceptionTranslator.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Test App J Hipster</a> &gt; <a href="index.source.html" class="el_package">com.theo.myjhipster.web.rest.errors</a> &gt; <span class="el_source">ExceptionTranslator.java</span></div><h1>ExceptionTranslator.java</h1><pre class="source lang-java linenums">package com.theo.myjhipster.web.rest.errors;

import com.theo.myjhipster.web.rest.util.HeaderUtil;

import org.springframework.dao.ConcurrencyFailureException;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.MethodArgumentNotValidException;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.context.request.NativeWebRequest;
import org.zalando.problem.DefaultProblem;
import org.zalando.problem.Problem;
import org.zalando.problem.ProblemBuilder;
import org.zalando.problem.Status;
import org.zalando.problem.spring.web.advice.ProblemHandling;
import org.zalando.problem.violations.ConstraintViolationProblem;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.stream.Collectors;

/**
 * Controller advice to translate the server side exceptions to client-friendly json structures.
 * The error response follows RFC7807 - Problem Details for HTTP APIs (https://tools.ietf.org/html/rfc7807)
 */
@ControllerAdvice
<span class="fc" id="L31">public class ExceptionTranslator implements ProblemHandling {</span>

    private static final String FIELD_ERRORS_KEY = &quot;fieldErrors&quot;;
    private static final String MESSAGE_KEY = &quot;message&quot;;
    private static final String PATH_KEY = &quot;path&quot;;
    private static final String VIOLATIONS_KEY = &quot;violations&quot;;

    /**
     * Post-process the Problem payload to add the message key for the front-end if needed
     */
    @Override
    public ResponseEntity&lt;Problem&gt; process(@Nullable ResponseEntity&lt;Problem&gt; entity, NativeWebRequest request) {
<span class="pc bpc" id="L43" title="1 of 2 branches missed.">        if (entity == null) {</span>
<span class="nc" id="L44">            return entity;</span>
        }
<span class="fc" id="L46">        Problem problem = entity.getBody();</span>
<span class="pc bpc" id="L47" title="1 of 4 branches missed.">        if (!(problem instanceof ConstraintViolationProblem || problem instanceof DefaultProblem)) {</span>
<span class="fc" id="L48">            return entity;</span>
        }
<span class="fc" id="L50">        ProblemBuilder builder = Problem.builder()</span>
<span class="fc bfc" id="L51" title="All 2 branches covered.">            .withType(Problem.DEFAULT_TYPE.equals(problem.getType()) ? ErrorConstants.DEFAULT_TYPE : problem.getType())</span>
<span class="fc" id="L52">            .withStatus(problem.getStatus())</span>
<span class="fc" id="L53">            .withTitle(problem.getTitle())</span>
<span class="fc" id="L54">            .with(PATH_KEY, request.getNativeRequest(HttpServletRequest.class).getRequestURI());</span>

<span class="pc bpc" id="L56" title="1 of 2 branches missed.">        if (problem instanceof ConstraintViolationProblem) {</span>
<span class="nc" id="L57">            builder</span>
<span class="nc" id="L58">                .with(VIOLATIONS_KEY, ((ConstraintViolationProblem) problem).getViolations())</span>
<span class="nc" id="L59">                .with(MESSAGE_KEY, ErrorConstants.ERR_VALIDATION);</span>
        } else {
<span class="fc" id="L61">            builder</span>
<span class="fc" id="L62">                .withCause(((DefaultProblem) problem).getCause())</span>
<span class="fc" id="L63">                .withDetail(problem.getDetail())</span>
<span class="fc" id="L64">                .withInstance(problem.getInstance());</span>
<span class="fc" id="L65">            problem.getParameters().forEach(builder::with);</span>
<span class="pc bpc" id="L66" title="1 of 4 branches missed.">            if (!problem.getParameters().containsKey(MESSAGE_KEY) &amp;&amp; problem.getStatus() != null) {</span>
<span class="fc" id="L67">                builder.with(MESSAGE_KEY, &quot;error.http.&quot; + problem.getStatus().getStatusCode());</span>
            }
        }
<span class="fc" id="L70">        return new ResponseEntity&lt;&gt;(builder.build(), entity.getHeaders(), entity.getStatusCode());</span>
    }

    @Override
    public ResponseEntity&lt;Problem&gt; handleMethodArgumentNotValid(MethodArgumentNotValidException ex, @Nonnull NativeWebRequest request) {
<span class="fc" id="L75">        BindingResult result = ex.getBindingResult();</span>
<span class="fc" id="L76">        List&lt;FieldErrorVM&gt; fieldErrors = result.getFieldErrors().stream()</span>
<span class="fc" id="L77">            .map(f -&gt; new FieldErrorVM(f.getObjectName(), f.getField(), f.getCode()))</span>
<span class="fc" id="L78">            .collect(Collectors.toList());</span>

<span class="fc" id="L80">        Problem problem = Problem.builder()</span>
<span class="fc" id="L81">            .withType(ErrorConstants.CONSTRAINT_VIOLATION_TYPE)</span>
<span class="fc" id="L82">            .withTitle(&quot;Method argument not valid&quot;)</span>
<span class="fc" id="L83">            .withStatus(defaultConstraintViolationStatus())</span>
<span class="fc" id="L84">            .with(MESSAGE_KEY, ErrorConstants.ERR_VALIDATION)</span>
<span class="fc" id="L85">            .with(FIELD_ERRORS_KEY, fieldErrors)</span>
<span class="fc" id="L86">            .build();</span>
<span class="fc" id="L87">        return create(ex, problem, request);</span>
    }

    @ExceptionHandler
    public ResponseEntity&lt;Problem&gt; handleNoSuchElementException(NoSuchElementException ex, NativeWebRequest request) {
<span class="nc" id="L92">        Problem problem = Problem.builder()</span>
<span class="nc" id="L93">            .withStatus(Status.NOT_FOUND)</span>
<span class="nc" id="L94">            .with(MESSAGE_KEY, ErrorConstants.ENTITY_NOT_FOUND_TYPE)</span>
<span class="nc" id="L95">            .build();</span>
<span class="nc" id="L96">        return create(ex, problem, request);</span>
    }

    @ExceptionHandler
    public ResponseEntity&lt;Problem&gt; handleBadRequestAlertException(BadRequestAlertException ex, NativeWebRequest request) {
<span class="fc" id="L101">        return create(ex, request, HeaderUtil.createFailureAlert(ex.getEntityName(), ex.getErrorKey(), ex.getMessage()));</span>
    }

    @ExceptionHandler
    public ResponseEntity&lt;Problem&gt; handleConcurrencyFailure(ConcurrencyFailureException ex, NativeWebRequest request) {
<span class="fc" id="L106">        Problem problem = Problem.builder()</span>
<span class="fc" id="L107">            .withStatus(Status.CONFLICT)</span>
<span class="fc" id="L108">            .with(MESSAGE_KEY, ErrorConstants.ERR_CONCURRENCY_FAILURE)</span>
<span class="fc" id="L109">            .build();</span>
<span class="fc" id="L110">        return create(ex, problem, request);</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.2.201808211720</span></div></body></html>